package eu.mhsl.craftattack.worldmuseum.util;

import eu.mhsl.craftattack.worldmuseum.worlds.World;
import net.minestom.server.MinecraftServer;
import net.minestom.server.entity.Player;
import net.minestom.server.utils.chunk.ChunkUtils;
import java.util.ArrayList;
import java.util.concurrent.CompletableFuture;
import java.util.concurrent.Future;

public class ChangeWorld {
    public static void change_world(Player player, World targetWorld) {
        ArrayList<Future> futures = new ArrayList<>();
        ChunkUtils.forChunksInRange(targetWorld.getSpawn(), MinecraftServer.getChunkViewDistance(),(v1, v2) -> {
            futures.add(targetWorld.loadChunk(v1, v2));
        });
        CompletableFuture.allOf(futures.toArray(CompletableFuture[]::new)).thenRun(()-> {
            player.setRespawnPoint(targetWorld.getSpawn());
            player.setInstance(targetWorld);
            player.teleport(targetWorld.getSpawn());
        });
    }
}
